<?php 
/**
 * Preytext
 *
 * Este archivo del código fuente hace parte de Preytext Framework.
 * Puedes encontrar mas información en > http://preytext.org
 *
 * @package     Preytext
 * @version     1.0
 *
 * @author      Jose Pino (Fraph) / <preytext@gmail.com> / @mrjopino
 * @copyright   © 2014 - Preytext CMS / @preytext
 *
 */

 $preytext = md5(''.time());
 $_SESSION['preytext'] = $token;
 setcookie("preytext", $preytext);

 $generador = "Preytext";

 $version_preytext = "1.0";

 $twitter_preytext = "@preytext";
 
 $url_preytext = "http://preytext.org";

 $ruta_url_preytext = "http://" . $_SERVER["HTTP_HOST"] . $_SERVER["REQUEST_URI"];

 $error_pt = "http://" . $_SERVER["HTTP_HOST"];

 $tipo_panel = "administración";

 // Menu
 $tipo_menu = "menu";
 $menu_text1 = "Dashboard";
 $menu_text2 = "Analytics";
 $menu_text3 = "Txt a json";
 $menu_text4 = "Acerca";
 $menu_text5 = "Blog";
 $menu_text6 = "Configuración";
 $menu_text7 = "Salir";


function preytext_copyright($inicio_año_preytext){
 
    $inicio_año_preytext = intval($inicio_año_preytext);
 
    $año_copyright = intval(date('Y'));

    if ($año_copyright > $inicio_año_preytext)

        return $inicio_año_preytext .'-'. $año_copyright;
    else
        return $inicio_año_preytext;
}

function tags_publicacion($string) { 
     $string = preg_replace ('/<[^>]*>/', ' ', $string); 
     $string = str_replace("\r", '', $string);
     $string = str_replace("\n", ' ', $string);
     $string = str_replace("\t", ' ', $string);   
     $string = trim(preg_replace('/ {2,}/', ' ', $string));
     return $string; 
}
/**
 * Filsany
 *
 * Sanitize Filter Cross-site scripting XSS Clean.
 *
 * @author José Pino (Fraph) / @Fr4phc0r3
 *
 */
function Filsany($aXSS) {
    $aXSS = str_replace("&", "&amp;", $aXSS);
    $aXSS = str_replace("'", "&#39;", $aXSS);
    $aXSS = str_replace("-", "&#45;", $aXSS);
    $aXSS = str_replace("_", "&#95;", $aXSS);
    $aXSS = str_replace("=", "&#61;", $aXSS);
    $aXSS = str_replace("(", "&#40;", $aXSS);
    $aXSS = str_replace(")", "&#41;", $aXSS);
    $aXSS = str_replace('<button', '&#60;button', $aXSS);
    $aXSS = str_replace('<BUTTON', '&#60;BUTTON', $aXSS);
    $aXSS = str_replace('<iframe', '&#60;iframe', $aXSS);
    $aXSS = str_replace('<IFRAME', '&#60;IFRAME', $aXSS);
    $aXSS = str_replace('document.cookie', '[cleanxss]', $aXSS);
    $aXSS = str_replace('document.domain', '[cleanxss]', $aXSS);
    $aXSS = str_replace('document.write', '[cleanxss]', $aXSS);
    $aXSS = str_replace('<script>', '&#60;script&#62;', $aXSS);
    $aXSS = str_replace('<SCRIPT>', '&#60;SCRIPT&#62;', $aXSS);
    return $aXSS;
}

function Filsany_about($aXSS) {
    $aXSS = str_replace("&", "&amp;", $aXSS);
    $aXSS = str_replace("-", "&#45;", $aXSS);
    $aXSS = str_replace("_", "&#95;", $aXSS);
    $aXSS = str_replace("(", "&#40;", $aXSS);
    $aXSS = str_replace(")", "&#41;", $aXSS);
    $aXSS = str_replace('<button', '&#60;button', $aXSS);
    $aXSS = str_replace('<BUTTON', '&#60;BUTTON', $aXSS);
    $aXSS = str_replace('<iframe', '&#60;iframe', $aXSS);
    $aXSS = str_replace('<IFRAME', '&#60;IFRAME', $aXSS);
    $aXSS = str_replace('document.cookie', '[cleanxss]', $aXSS);
    $aXSS = str_replace('document.domain', '[cleanxss]', $aXSS);
    $aXSS = str_replace('document.write', '[cleanxss]', $aXSS);
    $aXSS = str_replace('<script>', '&#60;script&#62;', $aXSS);
    $aXSS = str_replace('<SCRIPT>', '&#60;SCRIPT&#62;', $aXSS);
    $aXSS = str_replace('<!--', '&lt;!--', $aXSS);
    $aXSS = str_replace('-->', '--&gt;', $aXSS);
    return $aXSS;
}

function FilsanyClean($aXSS) {
    $aXSS = str_replace('document.cookie', '[cleanxss]', $aXSS);
    $aXSS = str_replace('document.domain', '[cleanxss]', $aXSS);
    $aXSS = str_replace('document.write', '[cleanxss]', $aXSS);
    $aXSS = str_replace('.parentNode', '[cleanxss]', $aXSS);
    $aXSS = str_replace('.innerHTML', '[cleanxss]', $aXSS);
    $aXSS = str_replace('<![CDATA[', '&lt;![CDATA[', $aXSS);
    $aXSS = str_replace('script', '[cleanxss]', $aXSS);
    $aXSS = str_replace('img', '[cleanxss]', $aXSS);
    $aXSS = str_replace('IMG', '[cleanxss]', $aXSS);
    $aXSS = str_replace('style', '[cleanxss]', $aXSS);
    $aXSS = str_replace('alert', '[cleanxss]', $aXSS);
    $aXSS = str_replace('prompt', '[cleanxss]', $aXSS);
    $aXSS = str_replace('confirm', '[cleanxss]', $aXSS);
    $aXSS = str_replace('onload', '[cleanxss]', $aXSS);
    $aXSS = str_replace('onerror', '[cleanxss]', $aXSS);
    $aXSS = str_replace('src=', '[cleanxss]', $aXSS);
    $aXSS = str_replace('SRC=', '[cleanxss]', $aXSS);
    $aXSS = str_replace('div', '[cleanxss]', $aXSS);
    $aXSS = str_replace('<button', '&#60;button', $aXSS);
    $aXSS = str_replace('<BUTTON', '&#60;BUTTON', $aXSS);
    $aXSS = str_replace('<iframe', '&#60;iframe', $aXSS);
    $aXSS = str_replace('<IFRAME', '&#60;IFRAME', $aXSS);
    $aXSS = str_replace('<comment>', '&lt;comment&gt;', $aXSS);
    $aXSS = str_replace('<script>', '&#60;script&#62;', $aXSS);
    $aXSS = str_replace('<SCRIPT>', '&#60;SCRIPT&#62;', $aXSS);
    $aXSS = str_replace('<!--', '&lt;!--', $aXSS);
    $aXSS = str_replace('-->', '--&gt;', $aXSS);
    return $aXSS;
}

// clase CSRF -> Independent
class RequestProtection {
    private $previous_hash;
    public $hash;

    function __construct() {

        if( isset($_SESSION['request_token']) ) {
            $this->previous_hash = $_SESSION['request_token'];
        }

        $this->hash = $_SESSION['request_token'] = crypt(uniqid());
            }
    public function valido($key = 'csrf_token') {
        return (isset($_POST[$key]) && ($_POST[$key] == $this->previous_hash)) ||
               (isset($_GET[$key]) && ($_GET[$key] == $this->previous_hash));
    }
    public function meta_tag_CSRF() {
        return '<meta name="csrf_token" value="' . $this->hash .'"/>';

    }
}